<!DOCTYPE html>
<html>
<head>
<title> Bootstrap template- Pizza 365 project </title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">

<!-- font -->
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

<!-- Bootstrap -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<style>
  .rounded-border {
    border-radius: 10em;
  }
</style>

<body onload="onPageLoading()" style="background-color: oldlace">
  <!-- Menu -->
  <div class="container-fluid bg-light">
    <div class="row">
      <div class="col-sm-12">
        <nav class="navbar fixed-top navbar-expand-lg navbar-light" style="background-color: #f0daa1">
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
            aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav nav-fill w-100">
              <li class="nav-item active">
                <a class="nav-link" href="#">Home</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#plans">Combo</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#about">Pizza</a>
              </li>
              <li class="nav-item">  <!-- đổi thành dạng click để dễ xử lý-->
                <button class="btn" onclick = "onNavOrderDetailClick()" >Order Detail</button>
              </li>
            </ul>
          </div>
        </nav>
      </div>  
    </div>
  </div>

  <!-- Content -->
  <div class="container" style="padding: 120px 0 50px 0;">
    <div class="row">
      <div class="col-sm-12">
        <div class="row">
          <!-- Title row home -->
          <div class="col-sm-12 text-center">
            <h1><b>PIZZA 365</b></h1> 
            <p><i>Truly Italian !</i></p>
          </div>

          <!-- Slide row home -->
          <div class="col-sm-12">
            <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
              <ol class="carousel-indicators">
                <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="3"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="4"></li>
              </ol>
              <div class="carousel-inner">
                <div class="carousel-item active">
                  <img class="d-block w-100" src="images/mon_y_1.jpg" alt="First slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_2.jpg" alt="Second slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_3.jpg" alt="Third slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_4.jpg" alt="Forth slide">
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/mon_y_5.jpg" alt="Fifth slide">
                </div>
              </div>
              <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
              </a>
              <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
              </a>
            </div>
          </div>

          <!-- Title Tại sao lại Pizza 365? -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Tại sao lại Pizza 365?</b></h2>
        </div>

        <!-- Content Tại sao lại Pizza 365? -->
        <div class="col-sm-12">
          <div class="row">
            <div class="col-sm-3 text-dark p-4 border" style="background-color: #FCC179">
              <h3 class="p-2">HOMEMADE</h3>
              <p class="p-2">"Tự sản xuất" là câu trả lời cho việc để có linh hồn của món ăn là phô mai luôn tươi mới, ngon và an toàn.</p>
            </div>
            <div class="col-sm-3 text-dark p-4 border" style="background-color: #fb9d14">
              <h3 class="p-2">HƯƠNG VỊ</h3>
              <p class="p-2">Món ăn mang hương vị tuyệt hảo đến từ nguồn nguyên liệu thượng hạng và những đầu bếp nổi tiếng.</p>
            </div>
            <div class="col-sm-3 p-4 text-dark border" style="background-color: #f78404">
              <h3 class="p-2">VƯỢT TRỘI</h3>
              <p class="p-2">Mang lại dịch vụ nhanh chóng, dễ dàng và đồ ăn ngon, giá cả hợp lý cùng tiêu chuẩn cao về an toàn và chất lượng.</p>
            </div>
            <div class="col-sm-3 p-4 text-dark border" style="background-color: #ee7804">
              <h3 class="p-2">DỊCH VỤ</h3>
              <p class="p-2">Phong cách phục vụ nhiệt tình, thân thiện mang đến trải nghiệm và sự hài lòng cao nhất cho khách hàng.</p>
            </div>
          </div>
        </div>
        </div>

        <div id="plans" class="row">
          <!-- Title Menu Combo -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-1 border-bottom">Menu Combo Pizza 365</b></h2>
            <p><span class="p-2">Hãy chọn cỡ pizza phù hợp với bạn!</span></p>
          </div>
          <!-- Content Menu Combo -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header text-dark text-center" style="background-color: #fb9d14">
                    <h3>S (Small)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">Đường kính: <b>20cm</b></li>
                      <li class="list-group-item">Sườn nướng: <b>2</b></li>
                      <li class="list-group-item">Salad: <b>200g</b></li>
                      <li class="list-group-item">Nước ngọt: <b>2</b></li>
                      <li class="list-group-item"><h2><b>VND 150.000</b></h2></li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-small" class="btn btn-secondary w-100 rounded-border" data-is-selected-menu="N" onclick="onSizeSmallClick()">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header text-dark text-center" style="background-color: #FCC179">
                    <h3>M (Medium)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">Đường kính: <b>25cm</b></li>
                      <li class="list-group-item">Sườn nướng: <b>4</b></li>
                      <li class="list-group-item">Salad: <b>300g</b></li>
                      <li class="list-group-item">Nước ngọt: <b>3</b></li>
                      <li class="list-group-item"><h2><b>VND 200.000</b></h2></li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-medium" class="btn btn-secondary w-100 rounded-border" data-is-selected-menu="N" onclick="onSizeMediumClick()">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header text-dark text-center" style="background-color: #fb9d14">
                    <h3>L (Large)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">Đường kính: <b>30cm</b></li>
                      <li class="list-group-item">Sườn nướng: <b>6</b></li>
                      <li class="list-group-item">Salad: <b>500g</b></li>
                      <li class="list-group-item">Nước ngọt: <b>4</b></li>
                      <li class="list-group-item"><h2><b>VND 250.000</b></h2></li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-large" class="btn btn-secondary w-100 rounded-border" data-is-selected-menu="N" onclick="onSizeLargeClick()">Chọn</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="about" class="row">
          <!-- Title Chọn loại Pizza -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Chọn loại Pizza</b></h2>
          </div>
          <!-- Content Chọn loại Pizza -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <div class="card-header text-dark text-center" style="background-color: #fb9d14">
                    <h3>Chicken Pizza</h3>
                  </div>
                  <img src="images/pizza_type_1.jpg" class="card-img-top pt-1">
                  <div class="card-body">
                    <h3>Gà</h3>
                    <p>Phủ Giăm Bông, Thịt Gà Và Thơm Ngọt Dịu Trên Nền Sốt Cà Chua Truyền Thống.</p>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-chicken" class="btn btn-secondary w-100 rounded-border" data-is-selected-pizza="N" onclick="onBtnChickenClick()">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <div class="card-header text-dark text-center" style="background-color: #FCC179">
                    <h3>Seafood Pizza</h3>
                  </div>
                  <img src="images/pizza_type_2.jpg" class="card-img-top pt-1">
                  <div class="card-body">
                    <h3>Hải sản</h3>
                    <p>Các Loại Hải Sản, Ớt Chuông, Hành Tây Và Phô Mai Trên Nền Xốt Cheesy.</p>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-seafood" class="btn btn-secondary w-100 rounded-border" data-is-selected-pizza="N" onclick="onBtnSeafoodClick()">Chọn</button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem;">
                  <div class="card-header text-dark text-center" style="background-color: #fb9d14">
                    <h3>Bacon Pizza</h3>
                  </div>
                  <img src="images/pizza_type_3.jpg" class="card-img-top pt-1">
                  <div class="card-body">
                    <h3>Thịt hun khói</h3>
                    <p>Thơm Ngon Giàu Protein Với Thịt Xông Khói, Giăm Bông, Xúc Xích, Pepperoni.</p>
                  </div>
                  <div class="card-footer text-center">
                    <button id="btn-bacon" class="btn btn-secondary w-100 rounded-border" data-is-selected-pizza="N" onclick="onBtnBaconClick()">Chọn</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div class="row">
          <!-- Tittle Drink List -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Chọn đồ uống</b></h2>
          </div>
          <!-- Content Drink List -->
          <div class="col-sm-12">
            <select class="form-control" id="select-drink">
              <option value="none">Chọn đồ uống</option>
            </select>
          </div>
        </div>

        <div id="contact" class="row">
          <!-- Title Order Detail -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Thông tin chi tiết</b></h2>
          </div>
          <!-- Content Order Detail -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-12">
                <div class="form-group">
                  <label for="fullname">Họ và tên <span class="text-danger">(*)</span></label>
                  <input type="text" class="form-control" id="inp-fullname" placeholder="Họ và tên...">
                </div>
                <div class="form-group">
                  <label for="email">Email <span class="text-danger">(*)</span></label>
                  <input type="text" class="form-control" id="inp-email" placeholder="Email...">
                </div>
                <div class="form-group">
                  <label for="dien-thoai">Điện thoại <span class="text-danger">(*)</span></label>
                  <input type="text" class="form-control" id="inp-dien-thoai" placeholder="Điện thoại...">
                </div>
                <div class="form-group">
                  <label for="dia-chi">Địa chỉ <span class="text-danger">(*)</span></label>
                  <input type="text" class="form-control" id="inp-dia-chi" placeholder="Địa chỉ...">
                </div>
                <div class="form-group">
                  <label for="message">Lời nhắn</label>
                  <input type="text" class="form-control" id="inp-message" placeholder="Lời nhắn...">
                </div>
                <div class="form-group">
                  <label for="message">Mã giảm giá</label>
                  <input type="text" class="form-control" id="inp-voucher-id" placeholder="Mã giảm giá...">
                </div>
                <button type="button" class="btn btn-dark w-100 mt-1 rounded-border" onclick="onBtnCheckOrderClick()">Kiểm tra đơn</button>
              </div>
              <!-- Phần khách xác nhận thông tin và Gửi đơn hàng -->
              <div id="div-container" class="container rounded text-dark mt-3 pt-2 pb-2" style="display: none; background-color: #FCC179">
                <div class="form-group">
                  <p id="p-confirm-form">Nội dung đơn hàng ở đây</p>
                </div>
                <div class="form-group">
                  <button class="btn text-white w-100 rounded-border" style="background-color:#ee7804" onclick="onBtnSendOrderClick()">Gửi đơn</button>
                </div>
              </div>
              <!-- Phần Hiển thị cảm ơn kèm mã đơn hàng -->
              <div id="div-container-ordercode" class="container rounded text-dark mt-3 p-5" style="display: none; background-color: #FCC179">
                <div class="col-sm-12 text-center">
                  <h5>Cảm ơn bạn đã đặt hàng tại Pizza 365! Mã đơn hàng của bạn là:</h5>
                  <h5 id="h5-ordercode"><b>SjnGFKk5SN</b></h5>
                </div>
              </div>

            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Footer -->
  <div class="container-fluid p-5" style="background-color: #f0daa1">
    <div class="row text-center">
      <div class="col-sm-12">
        <p class="m-2">Pizzza 365 - New pizza, New way</p>
        <a href="#" class="btn btn-dark m-3"><i class="fa fa-arrow-up"></i></a>
        <div class="m-2">
          <i class="fa fa-facebook-official w3-hover-opacity"></i>
          <i class="fa fa-instagram w3-hover-opacity"></i>
          <i class="fa fa-snapchat w3-hover-opacity"></i>
          <i class="fa fa-pinterest-p w3-hover-opacity"></i>
          <i class="fa fa-twitter w3-hover-opacity"></i>
          <i class="fa fa-linkedin w3-hover-opacity"></i>
        </div>
      </div>
    </div>
  </div>
</body>
  
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */ 
  // các combo Pizza
  const gCOMBO_SMALL = "S";
  const gCOMBO_MEDIUM = "M";
  const gCOMBO_LARGE = "L";
  // các loại Pizza
  const gPIZZA_CHICKEN = "Chicken";
  const gPIZZA_SEAFOOD = "Seafood";
  const gPIZZA_BACON = "Bacon";

  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/";
  const gREQUEST_STATUS_OK = 200; // GET & PUT success
  const gREQUEST_CREATE_SUCCESS = 201;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  function onNavOrderDetailClick () {
    console.log("%cGọi chi tiết order ở đây", "color:blue");
  }

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // Hàm thực thi khi load trang/F5
  function onPageLoading() {
      // B1: Đọc dữ liệu
      // B2: Validate dữ liệu
      // B3: Call API để lấy dữ liệu đồ uống
      var vXmlHttpDrink = new XMLHttpRequest();
      callApiDrink(vXmlHttpDrink);
      vXmlHttpDrink.onreadystatechange = function() {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          // B4: xử lý front-end (load data đồ uống vào thẻ select)
          loadDrinkDataToSelect(vXmlHttpDrink);
        }
      }    
    }

  // Hàm thực thi khi size S được chọn (click)
  function onSizeSmallClick() {
    // đọc dữ liệu
    var vSelectedCombo = getCombo(gCOMBO_SMALL, 20, 2, 200, 2, 150000);
    // xử lý front-end
    vSelectedCombo.displayConsoleLog();
    changeColorButton(gCOMBO_SMALL);
  }

  // Hàm thực thi khi size M được chọn (click)
  function onSizeMediumClick() {
      // đọc dữ liệu
      var vSelectedCombo = getCombo(gCOMBO_MEDIUM, 25, 4, 300, 3, 200000);
      // xử lý front-end
      vSelectedCombo.displayConsoleLog();
      changeColorButton(gCOMBO_MEDIUM);
    }

  // Hàm thực thi khi size L được chọn (click)
  function onSizeLargeClick() {
    // đọc dữ liệu
    var vSelectedCombo = getCombo(gCOMBO_LARGE, 30, 6, 500, 4, 250000);
    // xử lý front-end
    vSelectedCombo.displayConsoleLog();
    changeColorButton(gCOMBO_LARGE);
  }

  // Hàm thực thi khi button chọn loại Pizza Chicken được click
  function onBtnChickenClick() {
    // đọc dữ liệu
    var vSelectedPizza = getPizza(gPIZZA_CHICKEN);
    // xử lý front-end
    vSelectedPizza.displayConsoleLog();
    changeColorButton(gPIZZA_CHICKEN);
  }
    
  // Hàm thực thi khi button chọn loại Pizza Seafood được click
  function onBtnSeafoodClick() {
    // đọc dữ liệu
    var vSelectedPizza = getPizza(gPIZZA_SEAFOOD);
    // xử lý front-end
    vSelectedPizza.displayConsoleLog();
    changeColorButton(gPIZZA_SEAFOOD);
  }
    
  // Hàm thực thi khi button chọn loại Pizza Bacon được click
  function onBtnBaconClick() {
    // đọc dữ liệu
    var vSelectedPizza = getPizza(gPIZZA_BACON);
    // xử lý front-end
    vSelectedPizza.displayConsoleLog();
    changeColorButton(gPIZZA_BACON);
  }
  
  // Hàm thực thi khi button Kiểm tra đơn được click
  function onBtnCheckOrderClick() {
    // khai báo đối tượng để chứa dữ liệu
    var vOrderConfirm = {
      kichCo: "",
      duongKinh: "",
      suon: "",
      salad: "",
      soLuongNuoc: "",
      idLoaiNuocUong: "",
      loaiPizza: "",
      idVourcher: "",
      hoTen: "",
      email: "",
      soDienThoai: "",
      diaChi: "",
      loiNhan: "",
      thanhTien: "",
      phanTramGiamGia: 0,
      priceActualVND: function() {
        return this.thanhTien * (1 - this.phanTramGiamGia / 100);
      }
    };
    // B1: Đọc dữ liệu
    getOrderData(vOrderConfirm);
    // B2: Kiểm tra dữ liệu
    var vDataCheck = checkOrderData(vOrderConfirm);
    if (vDataCheck) {
      // B3: Xử lý front-end
      showConfirmOrder(vOrderConfirm);
    }
  }
  
  // Hàm thực thi khi button Gửi đơn được click
  function onBtnSendOrderClick() {
     // khai báo object order để chứa thông tin đặt hàng
     var vOrderObj = {
      kichCo: "",
      duongKinh: "",
      suon: "",
      salad: "",
      soLuongNuoc: "",
      idLoaiNuocUong: "",
      loaiPizza: "",
      idVourcher: "",
      hoTen: "",
      email: "",
      soDienThoai: "",
      diaChi: "",
      loiNhan: "",
      thanhTien: ""
    };
    // B1: Thu thập data
    getOrderData(vOrderObj);
    // B2: Kiểm tra data
    var vDataValid = checkOrderData(vOrderObj);
    if (vDataValid) {
      // B3: Gọi API tạo đơn hàng mới
      var vXmlHttpCreateOrder = new XMLHttpRequest();
      callApiNewOrder(vOrderObj, vXmlHttpCreateOrder);
      vXmlHttpCreateOrder.onreadystatechange = function() {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) {
          // B4: Xử lý front-end
          console.log(vXmlHttpCreateOrder.responseText);
          displayOrderCode(vXmlHttpCreateOrder);
        }
      }
    }    
  }
  
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // function gọi API lấy data đồ uống
  function callApiDrink(paramXmlHttp) {
    paramXmlHttp.open("GET", gBASE_URL + "drinks" , true);
    paramXmlHttp.send();
  }

  // function gọi API tạo order mới
  function callApiNewOrder(paramOrder, paramXmlHttp) {
    var vStringOrder = JSON.stringify(paramOrder);
    paramXmlHttp.open("POST", gBASE_URL + "orders" , true);
    paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
    paramXmlHttp.send(vStringOrder);
  }

  // function load data đồ uống lên thẻ Select Drink
  function loadDrinkDataToSelect(paramXmlHttp) {
    var vSelectDrinkElement = document.getElementById("select-drink");
    var vResponse = JSON.parse(paramXmlHttp.responseText);
    for (var bIndex = 0; bIndex < vResponse.length; bIndex ++) {
      // tạo thẻ option mới
      var vDrinkOption = document.createElement("option");
      // gán giá trị cho thẻ option
      vDrinkOption.value = vResponse[bIndex].maNuocUong;
      vDrinkOption.text = vResponse[bIndex].tenNuocUong;
      // thêm thẻ option đã tạo vào thẻ select drink
      vSelectDrinkElement.appendChild(vDrinkOption);
    }
  }

  // function getCombo (lấy thông tin Combo được chọn)
  // function trả lại một đối tượng được tham số hóa
  function getCombo(paramTenCombo, paramDuongKinh, paramSuonNuong, paramSalad, paramNuocNgot, paramGiaBan) {
    var vSelectedCombo = {
      tenCombo: "",
      duongKinh: "",
      suonNuong: "",
      salad: "",
      nuocNgot: "",
      giaBan: -1,
      // function hiển thị ra console
      displayConsoleLog: function() {
        console.log("%c COMBO SELECTED", "color: blue");
        console.log("Loại Combo: " + this.tenCombo);
        console.log("Đường kính: " + this.duongKinh + "cm");
        console.log("Sườn nướng: " + this.suonNuong);
        console.log("Salad: " + this.salad + "g");
        console.log("Nước ngọt: " + this.nuocNgot);
        console.log("Giá bán (VND): " + this.giaBan);
      }
    };
    vSelectedCombo.tenCombo = paramTenCombo;
    vSelectedCombo.duongKinh = paramDuongKinh;
    vSelectedCombo.suonNuong = paramSuonNuong;
    vSelectedCombo.salad = paramSalad;
    vSelectedCombo.nuocNgot = paramNuocNgot;
    vSelectedCombo.giaBan = paramGiaBan;
    return vSelectedCombo;
  }

  // function getPizza (lấy thông tin loại Pizza được chọn)
  // function trả lại một đối tượng được tham số hóa
  function getPizza(paramLoaiPizza) {
    var vSelectedPizza = {
      tenPizza: paramLoaiPizza,
      displayConsoleLog: function() {
        console.log("%c PIZZA SELECTED", "color: blue");
        console.log("Loại Pizza: " + this.tenPizza);
      }
    }
    return vSelectedPizza;
  }

  // function đổi màu nút button theo size bánh đã chọn
  function changeColorButton(paramInput) {
    // phần code đổi màu cho 3 button khu chọn size pizza (S, M, L)
    var vButtonSmall = document.getElementById("btn-small");
    var vButtonMedium = document.getElementById("btn-medium");
    var vButtonLarge = document.getElementById("btn-large");
    // Button chọn Size Small
    if (paramInput == gCOMBO_SMALL) {
      vButtonSmall.className = "btn btn-warning w-100 rounded-border";
      vButtonSmall.setAttribute("data-is-selected-menu","Y");

      vButtonMedium.className = "btn btn-secondary w-100 rounded-border rounded-border";
      vButtonMedium.setAttribute("data-is-selected-menu","N");

      vButtonLarge.className = "btn btn-secondary w-100 rounded-border rounded-border";
      vButtonLarge.setAttribute("data-is-selected-menu","N");
    }
    // Button chọn Size Medium
    else if (paramInput == gCOMBO_MEDIUM) {
      vButtonSmall.className = "btn btn-secondary w-100 rounded-border rounded-border";
      vButtonSmall.setAttribute("data-is-selected-menu","N");

      vButtonMedium.className = "btn btn-warning w-100 rounded-border rounded-border";
      vButtonMedium.setAttribute("data-is-selected-menu","Y");

      vButtonLarge.className = "btn btn-secondary w-100 rounded-border rounded-border";
      vButtonLarge.setAttribute("data-is-selected-menu","N");
    }
    // Button chọn Size Large
    else if (paramInput == gCOMBO_LARGE) {
      vButtonSmall.className = "btn btn-secondary w-100 rounded-border rounded-border";
      vButtonSmall.setAttribute("data-is-selected-menu","N");

      vButtonMedium.className = "btn btn-secondary w-100 rounded-border rounded-border";
      vButtonMedium.setAttribute("data-is-selected-menu","N");

      vButtonLarge.className = "btn btn-warning w-100 rounded-border rounded-border";
      vButtonLarge.setAttribute("data-is-selected-menu","Y");
    }

    // phần code đổi màu cho 3 button khu chọn loại pizza (Chicken, Seafood, Bacon)
    var vButtonHawai = document.getElementById("btn-chicken");
    var vButtonSeafood = document.getElementById("btn-seafood");
    var vButtonBacon = document.getElementById("btn-bacon");
    // Button chọn pizza Chicken
    if (paramInput == gPIZZA_CHICKEN) {
      vButtonHawai.className = "btn btn-warning w-100 rounded-border";
      vButtonHawai.setAttribute("data-is-selected-pizza","Y");

      vButtonSeafood.className = "btn btn-secondary w-100 rounded-border";
      vButtonSeafood.setAttribute("data-is-selected-pizza","N");

      vButtonBacon.className = "btn btn-secondary w-100 rounded-border";
      vButtonBacon.setAttribute("data-is-selected-pizza","N");
    }
    // Button chọn pizza Seafood
    else if (paramInput == gPIZZA_SEAFOOD) {
      vButtonHawai.className = "btn btn-secondary w-100 rounded-border";
      vButtonHawai.setAttribute("data-is-selected-pizza","N");

      vButtonSeafood.className = "btn btn-warning w-100 rounded-border";
      vButtonSeafood.setAttribute("data-is-selected-pizza","Y");

      vButtonBacon.className = "btn btn-secondary w-100 rounded-border";
      vButtonBacon.setAttribute("data-is-selected-pizza","N");
    }
    // Button chọn pizza Bacon
    else if (paramInput == gPIZZA_BACON) {
      vButtonHawai.className = "btn btn-secondary w-100 rounded-border";
      vButtonHawai.setAttribute("data-is-selected-pizza","N");

      vButtonSeafood.className = "btn btn-secondary w-100 rounded-border";
      vButtonSeafood.setAttribute("data-is-selected-pizza","N");

      vButtonBacon.className = "btn btn-warning w-100 rounded-border";
      vButtonBacon.setAttribute("data-is-selected-pizza","Y");
    }
  }
  
  // function đọc dữ liệu từ form người dùng nhập
  // input: đối tượng paramOrderConfirm để lưu các thông tin người dùng nhập
  // output: đối tượng paramOrderConfirm được gán dữ liệu tham số hóa
  function getOrderData(paramOrderConfirm) {
    // Truy xuất thuộc tính các phần tử input
    var vFullNameInput = document.getElementById("inp-fullname");
    var vEmailInput = document.getElementById("inp-email");
    var vPhoneInput = document.getElementById("inp-dien-thoai");
    var vAddressInput = document.getElementById("inp-dia-chi");
    var vMessageInput = document.getElementById("inp-message");
    var vVoucherInput = document.getElementById("inp-voucher-id");
    var vDrinkSelect = document.getElementById("select-drink");
    // Gán dữ liệu vào đối tượng paramOrderConfirm
    paramOrderConfirm.hoTen = vFullNameInput.value.trim();
    paramOrderConfirm.email = vEmailInput.value.trim();
    paramOrderConfirm.soDienThoai = vPhoneInput.value.trim();
    paramOrderConfirm.diaChi = vAddressInput.value.trim();
    paramOrderConfirm.loiNhan = vMessageInput.value.trim();
    paramOrderConfirm.idVourcher = vVoucherInput.value.trim();
    paramOrderConfirm.idLoaiNuocUong = vDrinkSelect.value;
    // kiểm tra dữ liệu menu combo được chọn
    // truy xuất thuộc tính phần tử 3 nút chọn menu combo
    var vButtonSmall = document.getElementById("btn-small");
    var vButtonMedium = document.getElementById("btn-medium");
    var vButtonLarge = document.getElementById("btn-large");
    // truy xuất thuộc tính data-is-selected-menu phần tử 3 nút chọn menu combo
    var vSmallSelected = vButtonSmall.getAttribute("data-is-selected-menu");
    var vMediumSelected = vButtonMedium.getAttribute("data-is-selected-menu");
    var vLargeSelected = vButtonLarge.getAttribute("data-is-selected-menu");
    // gán giá trị gói menu combo được chọn cho đối tượng paramOrderConfirm
    var vSelectedCombo = null;
    if (vSmallSelected == "Y") {
      vSelectedCombo = getCombo(gCOMBO_SMALL, 20, 2, 200, 2, 150000);
      paramOrderConfirm.kichCo = vSelectedCombo.tenCombo;
      paramOrderConfirm.duongKinh = vSelectedCombo.duongKinh;
      paramOrderConfirm.salad = vSelectedCombo.salad;
      paramOrderConfirm.suon = vSelectedCombo.suonNuong;
      paramOrderConfirm.soLuongNuoc = vSelectedCombo.nuocNgot;
      paramOrderConfirm.thanhTien = vSelectedCombo.giaBan;
    }
    else if (vMediumSelected == "Y") {
      vSelectedCombo = getCombo(gCOMBO_MEDIUM, 25, 4, 300, 3, 200000);
      paramOrderConfirm.kichCo = vSelectedCombo.tenCombo;
      paramOrderConfirm.duongKinh = vSelectedCombo.duongKinh;
      paramOrderConfirm.salad = vSelectedCombo.salad;
      paramOrderConfirm.suon = vSelectedCombo.suonNuong;
      paramOrderConfirm.soLuongNuoc = vSelectedCombo.nuocNgot;
      paramOrderConfirm.thanhTien = vSelectedCombo.giaBan;
    }
    else if (vLargeSelected == "Y") {
      vSelectedCombo = getCombo(gCOMBO_LARGE, 30, 6, 500, 4, 250000);
      paramOrderConfirm.kichCo = vSelectedCombo.tenCombo;
      paramOrderConfirm.duongKinh = vSelectedCombo.duongKinh;
      paramOrderConfirm.salad = vSelectedCombo.salad;
      paramOrderConfirm.suon = vSelectedCombo.suonNuong;
      paramOrderConfirm.soLuongNuoc = vSelectedCombo.nuocNgot;
      paramOrderConfirm.thanhTien = vSelectedCombo.giaBan;
    }
    
    // kiểm tra dữ liệu loại pizza được chọn
    var vSelectedPizza = null;
    // truy xuất thuộc tính phần tử 3 nút chọn loại pizza
    var vButtonChicken = document.getElementById("btn-chicken");
    var vButtonSeafood = document.getElementById("btn-seafood");
    var vButtonBacon = document.getElementById("btn-bacon");
    // truy xuất thuộc tính data-is-selected-pizza phần tử 3 nút chọn menu combo
    var vChickenSelected = vButtonChicken.getAttribute("data-is-selected-pizza");
    var vSeafoodSelected = vButtonSeafood.getAttribute("data-is-selected-pizza");
    var vBaconSelected = vButtonBacon.getAttribute("data-is-selected-pizza");
    // gán giá trị loại pizza được chọn cho đối tượng paramOrderConfirm
    if (vChickenSelected == "Y") {
      vSelectedPizza = getPizza(gPIZZA_CHICKEN);
      paramOrderConfirm.loaiPizza = vSelectedPizza.tenPizza;
    }
    else if (vSeafoodSelected == "Y") {
      vSelectedPizza = getPizza(gPIZZA_SEAFOOD);
      paramOrderConfirm.loaiPizza = vSelectedPizza.tenPizza;
    }
    else if (vBaconSelected == "Y") {
      vSelectedPizza = getPizza(gPIZZA_BACON);
      paramOrderConfirm.loaiPizza = vSelectedPizza.tenPizza;
    }
  }

  // function kiểm tra email
  // function return true nếu tất cả thông tin hợp lệ. Return false nếu có thông tin không hợp lệ
  function checkEmail(paramOrderConfirm) {
    var vCharBefore = paramOrderConfirm.email.split("@")[0];
    var vCharAfter = paramOrderConfirm.email.split("@")[1];
    if (paramOrderConfirm.email == "") {
      alert("Vui lòng nhập email");
      return false;
    }
    else if (!paramOrderConfirm.email.includes("@")) {
      alert("Email phải có @");
      return false;
    }
    else if (vCharBefore == "" || vCharAfter == "") {
      alert("Email phải có kí tự trước và sau @");
      return false;
    }
    return true;
  }

  // function kiểm tra dữ liệu trên form
  // function return true nếu tất cả thông tin hợp lệ. Return false nếu có thông tin không hợp lệ
  function checkOrderData(paramOrderConfirm) {
    // kiểm tra menu
    if (paramOrderConfirm.kichCo == "") {
      alert("Vui lòng chọn Menu Combo");
      return false;
    }
    // kiểm tra loại pizza
    else if (paramOrderConfirm.loaiPizza == "") {
      alert("Vui lòng chọn Loại Pizza");
      return false;
    }
    else if (paramOrderConfirm.idLoaiNuocUong == "none") {
      alert("Vui lòng chọn thức uống");
      return false;
    }
    else if (paramOrderConfirm.hoTen == "") {
      alert("Vui lòng nhập họ và tên");
      return false;
    }
    else if (!checkEmail(paramOrderConfirm)) {
      return false;
    }
    else if (paramOrderConfirm.soDienThoai == "") {
      alert("Vui lòng nhập số điện thoại");
      return false;
    }
    else if (paramOrderConfirm.diaChi == "") {
      alert("Vui lòng nhập địa chỉ");
      return false;
    }
    return true;
  }

  // function viết thông tin đơn hàng cần xác nhận lên form đã ẩn kèm nút bấm Gửi đơn
  function showConfirmOrder(paramOrderConfirm) {
    // truy xuất phần tử ô div chứa nội dung và thẻ p tổng hợp thông tin đơn hàng
    var vDivContainer = document.getElementById("div-container");
    var vPConfirmForm = document.getElementById("p-confirm-form");
    // lấy thông tin phanTramGiamGia từ voucher nhập trên form (nếu có)
    var vPhanTramGiamGia = findVoucher(paramOrderConfirm);
    paramOrderConfirm.phanTramGiamGia = vPhanTramGiamGia;
    // hiển thị thẻ div
    vDivContainer.style.display = "block";
    // hiển thị thông tin
    vPConfirmForm.innerHTML = "Họ và tên: " + paramOrderConfirm.hoTen + "<br>";
    vPConfirmForm.innerHTML += "Email: " + paramOrderConfirm.email + "<br>";
    vPConfirmForm.innerHTML += "Số điện thoại: " + paramOrderConfirm.soDienThoai + "<br>";
    vPConfirmForm.innerHTML += "Địa chỉ: " + paramOrderConfirm.diaChi + "<br>";
    vPConfirmForm.innerHTML += "Lời nhắn: " + paramOrderConfirm.loiNhan + "<br>";
    vPConfirmForm.innerHTML += "************************************ <br>";
    vPConfirmForm.innerHTML += "Kích cỡ: " + paramOrderConfirm.kichCo + "<br>";
    vPConfirmForm.innerHTML += "Đường kính: " + paramOrderConfirm.duongKinh + "cm<br>";
    vPConfirmForm.innerHTML += "Sườn nướng: " + paramOrderConfirm.suon + "<br>";
    vPConfirmForm.innerHTML += "Salad: " + paramOrderConfirm.salad + "g<br>";
    vPConfirmForm.innerHTML += "Nước ngọt: " + paramOrderConfirm.soLuongNuoc + "<br>";
    vPConfirmForm.innerHTML += "************************************ <br>";
    vPConfirmForm.innerHTML += "Loại Pizza: " + paramOrderConfirm.loaiPizza + "<br>";
    vPConfirmForm.innerHTML += "Loại nước uống: " + paramOrderConfirm.idLoaiNuocUong + "<br>";
    vPConfirmForm.innerHTML += "Mã Voucher: " + paramOrderConfirm.idVourcher + "<br>";
    vPConfirmForm.innerHTML += "Giá: VND " + paramOrderConfirm.thanhTien + "<br>";
    vPConfirmForm.innerHTML += "Giảm giá: " + paramOrderConfirm.phanTramGiamGia + "%<br>";
    vPConfirmForm.innerHTML += "Phải thanh toán: VND " + paramOrderConfirm.priceActualVND() + "<br>";
  }

  // function tìm voucher khách hàng nhập được lưu trong object paramOrderConfirm
  // functiont trả lại số % được giảm giá; return 0 nếu không tìm thấy voucher
  function findVoucher(paramOrderConfirm) {
    var vPhanTramGiamGia = 0;
    if (paramOrderConfirm.idVourcher != "") { // Nếu có điền mã voucher trên form thì:
      // tạo request và gửi yêu cầu lên server
      var vXmlHttpObj = new XMLHttpRequest();
      vXmlHttpObj.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/" + paramOrderConfirm.idVourcher, false);
      vXmlHttpObj.send();
      // nhận response từ server, check status
      var vResponseStatus = vXmlHttpObj.status;
      if (vResponseStatus == 200) {
        // nếu tìm thấy thì gán giá trị phần trăm giảm giá
        alert("Voucher hợp lệ. Bạn đã được giảm giá");
        var bResponseObj = JSON.parse(vXmlHttpObj.responseText);
        vPhanTramGiamGia = bResponseObj.phanTramGiamGia;
      }
      else {
        alert("Mã giảm giá không tồn tại");
      }
    }
    return vPhanTramGiamGia;
  }

  // function hiển thị phần Cảm ơn kèm Mã đơn hàng sau khi nhấn Gửi đơn hàng
  function displayOrderCode(paramXmlHttp) {
    // chuyển respose text sang object
    var vResponseObj = JSON.parse(paramXmlHttp.responseText);
    var vOrderCode = vResponseObj.orderCode;
    var vDivContainerOrderCode = document.getElementById("div-container-ordercode");
    var vDivContainerOrderConfirm = document.getElementById("div-container");
    var vH5Content = document.getElementById("h5-ordercode");
    // ẩn container order confirm
    vDivContainerOrderConfirm.style.display = "none";
    // hiển thị container order code
    vDivContainerOrderCode.style.display = "block";
    // hiện order code:
    vH5Content.innerHTML = vOrderCode;
  }

</script>

</html>